/* Performance timer class for Linux
** copyleft (C) Shawn Kirst (skirst@fuse.net) 2000
**
** you may email me for all questions and comments about this code.
*/

/*
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

/***************************************************************************
** IMPORTANT NOTE:  You must compile this source UN-OPTIMIZED.  It doesn't**
** work otherwise.  The code is small enough and hand optimized enough    **
** already to not need to worry about compiler optimizations.  It causes  **
** this code to fail, and I've yet to discover why.                       **
** Use this compile command:                                              **
** g++ timer.cpp -o timer.o                                               **
***************************************************************************/

#include <stdio.h>
#include <string.h>

#include "timer.h"

int timer_t::init(void)
{
   FILE *fp;
   float mhz=0;
   char s[256];

   /* get CPU speed from /proc/cpuinfo */
   if((fp=fopen("/proc/cpuinfo","r"))==NULL) return(0);

   while(fgets(s,sizeof(s),fp)!=NULL) {
      if(strstr(s,"cpu MHz")) {
		   sscanf(strchr(s,':')+1,"%f",&mhz);
			break;
		}
	}

	fclose(fp);

   if(mhz==0) return(0);

   freq=1/mhz;

   total=interval=0;
   counter=cputicks();

   return(1);
}

void timer_t::update(void)
{
   double prev;

   prev=total;
   total+=(double)(((cputicks()-counter)*freq)/1000000);
   interval=total-prev;
   counter=cputicks();
}
